I am in a 100-story building. I have with me two glass balls. I know that if I throw the ball out of the window, it will not break if the floor number is less than X, and it will always breaks if the floor number is equal to or greater than X. Assuming that I can reuse the balls which don't break, find X in the minimum number of throws.The answer is 14 . The strategy is to drop the first ball from the K -th story; if it breaks, you know that the answer is between 1 and K and you have to use at most K-1 drops to find it out, thus K drops will be used. It the first ball does not break when dropped from the K -th floor, you drop it again from the (K+K-1) -th floor, then, if it breaks, you find the critical floor between K+1 and K+K-1 in K-2 drops, i.e., again, the total number of drops is K . Continue until you get above the top floor or you drop the first ball K times. Therefore, you have to choose K so that the total number of floors covered in K steps, which is K(k+1)/2 , is greater that 100 (the total size of the building). 13*14/2=91 -- too small. 14*15/2=105 -- enough. This resembles with Skip List - https://sites.google.com/site/mytechnicalcollection/algorithms/lists/skip-lists The Skip list is equally divided. L1 | | | | | L2 |-----|-----|-----|-----| But here the total traversal is constant. So, for each top list traversal the lower list bucket goes on decreasing. This makes total traversal to reach any destination same in worst case and also min. (6 traversal in this case in worst case) L1 | | | | | L2 |-----|----|---|--| The following is a description of the instance of this famous puzzle involving n=2 eggs and a building with k=36 floors. Suppose that we wish to know which stories in a 36-story building are safe to drop eggs from, and which will cause the eggs to break on landing. We make a few assumptions: …..An egg that survives a fall can be used again. If only one egg is available and we wish to be sure of obtaining the right result, the experiment can be carried out in only one way. Drop the egg from the first-floor window; if it survives, drop it from the second floor window. Continue upward until it breaks. In the worst case, this method may require 36 droppings. Suppose 2 eggs are available. What is the least number of egg-droppings that is guaranteed to work in all cases? Source: Wiki for Dynamic Programming In this post, we will discuss solution to a general problem with n eggs and k floors. The solution is to try dropping an egg from every floor (from 1 to k) and recursively calculate the minimum number of droppings needed in worst case. The floor which gives the minimum value in worst case is going to be part of the solution. 1) Optimal Substructure: 1) If the egg breaks after dropping from xth floor, then we only need to check for floors lower than x with remaining eggs; so the problem reduces to x-1 floors and n-1 eggs Since we need to minimize the number of trials in worst case, we take the maximum of two cases. We consider the max of above two cases for every floor and choose the floor which yields minimum number of trials. k ==> Number of floors n ==> Number of Eggs eggDrop(n, k) ==> Minimum number of trails needed to find the critical floor in worst case. eggDrop(n, k) = 1 + min{max(eggDrop(n - 1, x - 1), eggDrop(n, k - x)): x in {1, 2, ..., k}} 2) Overlapping Subproblems Output: Minimum number of trials in worst case with 2 eggs and 10 floors is 4 It should be noted that the above function computes the same subproblems again and again. See the following partial recursion tree, E(2, 2) is being evaluated twice. There will many repeated subproblems when you draw the complete recursion tree even for small values of n and k. E(2,4) | ------------------------------------- | | | | | | | | x=1/\ x=2/\ x=3/ \ x=4/ \ / \ / \ .... .... / \ / \ E(1,0) E(2,3) E(1,1) E(2,2) /\ /\... / \ x=1/ \ ..... / \ E(1,0) E(2,2) / \ ...... Partial recursion tree for 2 eggs and 4 floors. Since same suproblems are called again, this problem has Overlapping Subprolems property. So Egg Dropping Puzzle has both properties (see this and this) of a dynamic programming problem. Like other typical Dynamic Programming(DP) problems, recomputations of same subproblems can be avoided by constructing a temporary array eggFloor[][] in bottom up manner. Dynamic Programming Solution Output: Minimum number of trials in worst case with 2 eggs and 36 floors is 8 Time Complexity: O(nk^2) As an exercise, you may try modifying the above DP solution to print all intermediate floors (The floors used for minimum trail solution). References: |
Algorithms > Dynamic Programming >